diff --git a/src/backend/catalog/pg_aggregate.c b/src/backend/catalog/pg_aggregate.c
index fe6dc8a..b7fc5f2 100644
*** a/src/backend/catalog/pg_aggregate.c
--- b/src/backend/catalog/pg_aggregate.c
*************** AggregateCreate(const char *aggName,
*** 56,61 ****
--- 56,62 ----
  				List *parameterDefaults,
  				Oid variadicArgType,
  				List *aggtransfnName,
+ 				List *agginvtransfnName,
  				List *aggfinalfnName,
  				List *aggsortopName,
  				Oid aggTransType,
*************** AggregateCreate(const char *aggName,
*** 68,78 ****
--- 69,81 ----
  	Datum		values[Natts_pg_aggregate];
  	Form_pg_proc proc;
  	Oid			transfn;
+ 	Oid			invtransfn = InvalidOid; /* can be omitted */
  	Oid			finalfn = InvalidOid;	/* can be omitted */
  	Oid			sortop = InvalidOid;	/* can be omitted */
  	Oid		   *aggArgTypes = parameterTypes->values;
  	bool		hasPolyArg;
  	bool		hasInternalArg;
+ 	bool		transIsStrict;
  	Oid			rettype;
  	Oid			finaltype;
  	Oid			fnArgs[FUNC_MAX_ARGS];
*************** AggregateCreate(const char *aggName,
*** 234,241 ****
--- 237,297 ----
  					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
  					 errmsg("must not omit initial value when transition function is strict and transition type is not compatible with input type")));
  	}
+ 
+ 	/*
+ 	 * Remember if trans function is strict as we need to validate this
+ 	 * later if when we're dealing with the inverse transition function
+ 	 */
+ 	transIsStrict = proc->proisstrict;
+ 
  	ReleaseSysCache(tup);
  
+ 	/* handle invtransfn, if supplied */
+ 	if (agginvtransfnName)
+ 	{
+ 		/*
+ 		 * This must have the same number of arguments with the same types as
+ 		 * the transition function. We can just borrow the argument details
+ 		 * from the transition function and try to find a function with
+ 		 * the name of the inverse transition function and with a signature
+ 		 * that matches the transition function's.
+ 		 */
+ 		invtransfn = lookup_agg_function(agginvtransfnName,
+ 					nargs_transfn, fnArgs, InvalidOid, &rettype);
+ 
+ 		/*
+ 		 * Ensure the return type of the inverse transition function matches
+ 		 * the expected type.
+ 		 */
+ 		if (rettype != aggTransType)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_DATATYPE_MISMATCH),
+ 						errmsg("return type of inverse transition function %s is not %s",
+ 							NameListToString(agginvtransfnName),
+ 							format_type_be(aggTransType))));
+ 
+ 		tup = SearchSysCache1(PROCOID, ObjectIdGetDatum(invtransfn));
+ 		if (!HeapTupleIsValid(tup))
+ 			elog(ERROR, "cache lookup failed for function %u", invtransfn);
+ 		proc = (Form_pg_proc) GETSTRUCT(tup);
+ 
+ 		/*
+ 		 * We force the strictness settings of the forward and inverse
+ 		 * transition functions to agree. This allows places which only need
+ 		 * forward transitions to not look at the inverse transition function
+ 		 * at all.
+ 		 */
+ 		if (transIsStrict != proc->proisstrict)
+ 		{
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_FUNCTION_DEFINITION),
+ 						errmsg("strictness of forward and inverse transition functions must match"
+ 						)));
+ 		}
+ 		ReleaseSysCache(tup);
+ 
+ 	}
+ 
  	/* handle finalfn, if supplied */
  	if (aggfinalfnName)
  	{
*************** AggregateCreate(const char *aggName,
*** 391,396 ****
--- 447,453 ----
  	values[Anum_pg_aggregate_aggkind - 1] = CharGetDatum(aggKind);
  	values[Anum_pg_aggregate_aggnumdirectargs - 1] = Int16GetDatum(numDirectArgs);
  	values[Anum_pg_aggregate_aggtransfn - 1] = ObjectIdGetDatum(transfn);
+ 	values[Anum_pg_aggregate_agginvtransfn - 1] = ObjectIdGetDatum(invtransfn);
  	values[Anum_pg_aggregate_aggfinalfn - 1] = ObjectIdGetDatum(finalfn);
  	values[Anum_pg_aggregate_aggsortop - 1] = ObjectIdGetDatum(sortop);
  	values[Anum_pg_aggregate_aggtranstype - 1] = ObjectIdGetDatum(aggTransType);
*************** AggregateCreate(const char *aggName,
*** 425,430 ****
--- 482,496 ----
  	referenced.objectSubId = 0;
  	recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
  
+ 	/* Depends on inverse transition function, if any */
+ 	if (OidIsValid(invtransfn))
+ 	{
+ 		referenced.classId = ProcedureRelationId;
+ 		referenced.objectId = invtransfn;
+ 		referenced.objectSubId = 0;
+ 		recordDependencyOn(&myself, &referenced, DEPENDENCY_NORMAL);
+ 	}
+ 
  	/* Depends on final function, if any */
  	if (OidIsValid(finalfn))
  	{
*************** AggregateCreate(const char *aggName,
*** 447,453 ****
  }
  
  /*
!  * lookup_agg_function -- common code for finding both transfn and finalfn
   */
  static Oid
  lookup_agg_function(List *fnName,
--- 513,520 ----
  }
  
  /*
!  * lookup_agg_function
!  * common code for finding transfn, invtransfn and finalfn
   */
  static Oid
  lookup_agg_function(List *fnName,
diff --git a/src/backend/commands/aggregatecmds.c b/src/backend/commands/aggregatecmds.c
index 640e19c..c0ea1f7 100644
*** a/src/backend/commands/aggregatecmds.c
--- b/src/backend/commands/aggregatecmds.c
*************** DefineAggregate(List *name, List *args, 
*** 60,65 ****
--- 60,66 ----
  	AclResult	aclresult;
  	char		aggKind = AGGKIND_NORMAL;
  	List	   *transfuncName = NIL;
+ 	List	   *invtransfuncName = NIL;
  	List	   *finalfuncName = NIL;
  	List	   *sortoperatorName = NIL;
  	TypeName   *baseType = NULL;
*************** DefineAggregate(List *name, List *args, 
*** 112,117 ****
--- 113,120 ----
  			transfuncName = defGetQualifiedName(defel);
  		else if (pg_strcasecmp(defel->defname, "sfunc1") == 0)
  			transfuncName = defGetQualifiedName(defel);
+ 		else if (pg_strcasecmp(defel->defname, "invsfunc") == 0)
+ 			invtransfuncName = defGetQualifiedName(defel);
  		else if (pg_strcasecmp(defel->defname, "finalfunc") == 0)
  			finalfuncName = defGetQualifiedName(defel);
  		else if (pg_strcasecmp(defel->defname, "sortop") == 0)
*************** DefineAggregate(List *name, List *args, 
*** 283,288 ****
--- 286,292 ----
  						   parameterDefaults,
  						   variadicArgType,
  						   transfuncName,		/* step function name */
+ 						   invtransfuncName,	/* inverse trans function name */
  						   finalfuncName,		/* final function name */
  						   sortoperatorName,	/* sort operator name */
  						   transTypeId, /* transition data type */
diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index 08f3167..beee43d 100644
*** a/src/backend/commands/explain.c
--- b/src/backend/commands/explain.c
*************** static void show_sort_group_keys(PlanSta
*** 85,90 ****
--- 85,91 ----
  					 List *ancestors, ExplainState *es);
  static void show_sort_info(SortState *sortstate, ExplainState *es);
  static void show_hash_info(HashState *hashstate, ExplainState *es);
+ static void show_windowagg_info(PlanState *planstate, ExplainState *es);
  static void show_tidbitmap_info(BitmapHeapScanState *planstate,
  								ExplainState *es);
  static void show_instrumentation_count(const char *qlabel, int which,
*************** ExplainNode(PlanState *planstate, List *
*** 1420,1425 ****
--- 1421,1430 ----
  		case T_Hash:
  			show_hash_info((HashState *) planstate, es);
  			break;
+ 		case T_WindowAgg:
+ 			if (es->verbose && planstate->instrument)
+ 				show_windowagg_info(planstate, es);
+ 			break;
  		default:
  			break;
  	}
*************** show_hash_info(HashState *hashstate, Exp
*** 1918,1923 ****
--- 1923,1943 ----
  	}
  }
  
+ static void
+ show_windowagg_info(PlanState *planstate, ExplainState *es)
+ {
+ 	WindowAggState *winaggstate = (WindowAggState *) planstate;
+ 	Instrumentation *inst = planstate->instrument;
+ 
+ 	if (inst->nloops > 0 && inst->ntuples > 0 && winaggstate->numaggs > 0)
+ 	{
+ 		double tperrow = winaggstate->aggfwdtrans /
+ 			(inst->nloops * inst->ntuples);
+ 
+ 		ExplainPropertyFloat("Transitions Per Row", tperrow, 1, es);
+ 	}
+ }
+ 
  /*
   * If it's EXPLAIN ANALYZE, show exact/lossy pages for a BitmapHeapScan node
   */
diff --git a/src/backend/executor/nodeAgg.c b/src/backend/executor/nodeAgg.c
index 7e4bca5..9a7ed93 100644
*** a/src/backend/executor/nodeAgg.c
--- b/src/backend/executor/nodeAgg.c
*************** ExecInitAgg(Agg *node, EState *estate, i
*** 1798,1805 ****
--- 1798,1807 ----
  								aggref->aggtype,
  								aggref->inputcollid,
  								transfn_oid,
+ 								InvalidOid, /* invtrans is not needed here */
  								finalfn_oid,
  								&transfnexpr,
+ 								NULL,
  								&finalfnexpr);
  
  		/* set up infrastructure for calling the transfn and finalfn */
*************** ExecReScanAgg(AggState *node)
*** 2127,2168 ****
  }
  
  /*
-  * AggCheckCallContext - test if a SQL function is being called as an aggregate
-  *
-  * The transition and/or final functions of an aggregate may want to verify
-  * that they are being called as aggregates, rather than as plain SQL
-  * functions.  They should use this function to do so.	The return value
-  * is nonzero if being called as an aggregate, or zero if not.	(Specific
-  * nonzero values are AGG_CONTEXT_AGGREGATE or AGG_CONTEXT_WINDOW, but more
-  * values could conceivably appear in future.)
-  *
-  * If aggcontext isn't NULL, the function also stores at *aggcontext the
-  * identity of the memory context that aggregate transition values are
-  * being stored in.
-  */
- int
- AggCheckCallContext(FunctionCallInfo fcinfo, MemoryContext *aggcontext)
- {
- 	if (fcinfo->context && IsA(fcinfo->context, AggState))
- 	{
- 		if (aggcontext)
- 			*aggcontext = ((AggState *) fcinfo->context)->aggcontext;
- 		return AGG_CONTEXT_AGGREGATE;
- 	}
- 	if (fcinfo->context && IsA(fcinfo->context, WindowAggState))
- 	{
- 		if (aggcontext)
- 			*aggcontext = ((WindowAggState *) fcinfo->context)->aggcontext;
- 		return AGG_CONTEXT_WINDOW;
- 	}
- 
- 	/* this is just to prevent "uninitialized variable" warnings */
- 	if (aggcontext)
- 		*aggcontext = NULL;
- 	return 0;
- }
- 
- /*
   * AggGetAggref - allow an aggregate support function to get its Aggref
   *
   * If the function is being called as an aggregate support function,
--- 2129,2134 ----
